package com.winhc.bigdata.spark.jobs

import com.winhc.bigdata.spark.udf.CommpanyMapping
import com.winhc.bigdata.spark.utils.SparkUtils
import org.apache.commons.logging.LogFactory
import org.apache.spark.sql.SparkSession

object CompanyInfoCalculator extends CommpanyMapping {

  private val LOG = LogFactory.getLog(this.getClass)

  def main(args: Array[String]): Unit = {
    val spark: SparkSession = SparkUtils.InitEnv

    import spark._
    LOG.info("company calc start!   ")
    println("company calc start!   ")

    prepare(spark)

    val tableName = "ads_company"
    val resultTable = "ads_company_score"

    val df = sql(
      s"""
         |SELECT  id
         |        ,company_name
         |        ,legal_person_name
         |        ,reg_capital
         |        ,reg_capital_score(reg_capital) AS reg_capital_score
         |        ,reg_capital_num
         |        ,actual_capital
         |        ,actual_capital_score(actual_capital,reg_capital) AS actual_capital_score
         |        ,category_code
         |        ,industry_score(category_code) AS industry_score
         |        ,company_type
         |        ,company_org_type
         |        ,company_type_score(company_org_type) AS company_type_score
         |        ,reg_status
         |        ,company_status_score(reg_status) AS company_status_score
         |        ,estiblish_time
         |        ,start_date_score(CAST(estiblish_time AS STRING)) AS start_date_score
         |        ,from_time
         |        ,to_time
         |        ,end_date_score(CAST(from_time AS STRING) ,CAST(to_time AS STRING)) AS end_date_score
         |        ,reg_location
         |        ,reg_location_score(reg_location) AS reg_location_score
         |FROM    ${tableName}
         |""".stripMargin)

    df.write.mode("overwrite").insertInto(resultTable)

    LOG.info("company calc end!   ")
    println("company calc end!   ")

    spark.stop();
  }


}
